<script setup lang="ts">
import {
  Chart as ChartJS,
  Title,
  Tooltip,
  Legend,
  BarElement,
  CategoryScale,
  LinearScale
} from 'chart.js'
import { Bar } from 'vue-chartjs'
import { Line } from 'vue-chartjs'
import { computed, onMounted, ref, watch } from 'vue'
import { reactive } from 'vue'
import receiptService from '@/services/receipt'
import { usereportSalesStore } from '@/stores/reportSales'
import { useAuthStore } from '@/stores/auth'

const reportSales = usereportSalesStore()
const authStore = useAuthStore()
const labelss = ref<string[]>([])
const dataValues = ref<number[]>([])
const data = ref([])
const datePicker = ref()
const reportnameType = ref('')
const isMonth = ref(false)
const isDays = ref(false)
const isYear = ref(false)
const t = ref(0)

async function setSalesDay() {
  t.value = 0
  labelss.value = []
  dataValues.value = []
  await reportSales.dailySales(authStore.getCurrentUser()?.id!, datePicker.value)

  labelss.value = reportSales.data.map((item: any) => {
    return item.Day
  })
  console.log('labels ' + labelss.value)
  dataValues.value = reportSales.data.map((item: any) => {
    return item.Total
  })
  console.log('dataValues ' + dataValues.value)
}

async function setSalesMonth() {
  t.value = 0
  labelss.value = []
  dataValues.value = []
  await reportSales.dailyMonth(authStore.getCurrentUser()?.id!)

  labelss.value = reportSales.data.map((item: any) => {
    return item.Month
  })
  console.log('labels ' + labelss.value)
  dataValues.value = reportSales.data.map((item: any) => {
    return item.Total
  })
  console.log('dataValues ' + dataValues.value)
}

async function setSalesYear() {
  t.value = 0
  labelss.value = []
  dataValues.value = []
  await reportSales.dailyYear(authStore.getCurrentUser()?.id!)

  labelss.value = reportSales.data.map((item: any) => {
    return item.Year
  })
  console.log('labels ' + labelss.value)
  dataValues.value = reportSales.data.map((item: any) => {
    return item.Total
  })
  console.log('dataValues ' + dataValues.value)
}

ChartJS.register(Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale)
const chartData = computed(() => ({
  labels: labelss.value,
  datasets: [
    {
      label: 'Sales',
      data: dataValues.value,
      backgroundColor: 'rgba(229, 72, 0)',
      borderWidth: 1
    }
  ]
}))

const chartOptions = {
  responsive: false,
  maintainAspectRation: true,
  scales: {
    x: {
      title: {
        display: true,
        text: 'Date'
      }
    },
    y: {
      title: {
        display: true,
        text: 'Sales Value'
      }
    }
  }
}

function isDMY() {
  if (isDays.value) {
    reportnameType.value = 'Daily Sales'
  } else if (isMonth.value) {
    reportnameType.value = 'Monthly Sales'
  } else {
    reportnameType.value = 'Yearly Sales'
  }
}

function isDay() {
  labelss.value = []
  dataValues.value = []
  isDays.value = true
  isMonth.value = false
  isYear.value = false
}

function isMonths() {
  labelss.value = []
  dataValues.value = []
  isMonth.value = true
  isDays.value = false
  isYear.value = false
  setSalesMonth()
}

function isYears() {
  labelss.value = []
  dataValues.value = []
  isYear.value = true
  isMonth.value = false
  isDays.value = false
  setSalesYear()
}

const selectedYear = ref(new Date().getFullYear())
function exactYear() {
  if (selectedYear.value) {
    const thisYear = datePicker.value.split('-')[0]
    datePicker.value = thisYear
    console.log('Date picker in Year ' + datePicker.value)
  }
}

onMounted(() => {
  setSalesDay()
})
</script>
<template>
  <div></div>
  <v-row>
    <v-col cols="12" sm="12" md="4">
      <p>Check your Sales Here</p>
      <v-btn @click="isDay(), isDMY()">Day</v-btn>
      <v-btn @click="isMonths(), isDMY()">Month</v-btn>
      <v-btn @click="isYears(), isDMY()">Year</v-btn>
      <v-text-field
        v-model="datePicker"
        label="Type Month"
        @input="setSalesDay()"
        v-if="isDays === true"
      ></v-text-field>
      <v-text-field
        v-model="selectedYear"
        label="Type Year"
        @input="setSalesMonth()"
        v-if="isMonth === true"
      ></v-text-field>
    </v-col>
    <v-col cols="12" sm="12" md="8">
      <p style="text-align: center; font-size: 40px">{{ reportnameType }}</p>
      <Bar :data="chartData" :options="chartOptions" width="700" v-if="isDays === true" />
      <Bar :data="chartData" :options="chartOptions" width="700" v-if="isMonth === true" />
      <Bar :data="chartData" :options="chartOptions" width="700" v-if="isYear === true" />
    </v-col>
  </v-row>
</template>
